/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.actionEnforcementModule.serviceCenterManagement.factories.impl;

import ro.utcn.dsrl.actionEnforcementModule.serviceCenterManagement.factories.ServiceCenterManagementFactory;
import ro.utcn.dsrl.actionEnforcementModule.serviceCenterManagement.ServiceCenterManagement;
import ro.utcn.dsrl.actionEnforcementModule.serviceCenterManagement.impl.OpenNebulaServiceCenterManagement;
import ro.utcn.dsrl.actionEnforcementModule.serviceCenterManagement.impl.StubServiceCenterManagement;
import ro.utcn.dsrl.utils.config.GeneralConfigurationManager;

/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */
public class DefaultServiceCenterManagementFactory implements ServiceCenterManagementFactory {

    private static DefaultServiceCenterManagementFactory factory;

    static {
        factory = new DefaultServiceCenterManagementFactory();
    }

    private DefaultServiceCenterManagementFactory() {
    }

    public static DefaultServiceCenterManagementFactory getInstance() {
        return factory;
    }

     public ServiceCenterManagement createServiceCenterManagement() {
        return (GeneralConfigurationManager.isStubServiceCenterManagement())? new StubServiceCenterManagement() : new OpenNebulaServiceCenterManagement();
    }
}
