/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/

package ro.utcn.dsrl.actionEnforcementModule.serviceCenterManagement.impl;

import java.util.logging.Level;
import java.util.logging.Logger;
import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;
import org.opennebula.client.Client;
import org.opennebula.client.OneResponse;
import org.opennebula.client.host.Host;
import org.opennebula.client.host.HostPool;
import org.opennebula.client.vm.VirtualMachine;
import org.opennebula.client.vm.VirtualMachinePool;
import org.opennebula.client.vnet.VirtualNetwork;
import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import ro.utcn.dsrl.actionEnforcementModule.serviceCenterManagement.ServiceCenterManagement;
import ro.utcn.dsrl.actionEnforcementModule.serviceCenterManagement.util.BPELCallUtil;
import ro.utcn.dsrl.actionEnforcementModule.serviceCenterManagement.util.OpenNebulaInfoXMLParser;
import ro.utcn.dsrl.utils.commonDtos.PhysicalHost;
import ro.utcn.dsrl.utils.commonDtos.ServerInfo;
import ro.utcn.dsrl.utils.commonDtos.VirtualNetworkInfo;
import ro.utcn.dsrl.utils.commonDtos.VirtualTaskInfo;
import ro.utcn.dsrl.utils.config.GeneralConfigurationManager;
import ro.utcn.dsrl.utils.exceptions.ServiceCenterAccessException;
import ro.utcn.dsrl.utils.logging.GlobalLoopLogger;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.io.*;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import ro.utcn.dsrl.utils.config.ARPTableManager;

/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */
public class OpenNebulaServiceCenterManagement implements ServiceCenterManagement {

    private final static String NEBULA_RCP_ADDRESS = GeneralConfigurationManager.getOpenNebulaRCPAddress();
    private final static String NEBULA_CREDENTIALS = GeneralConfigurationManager.getOpenNebulaCredentials();
    private static boolean SHUTDOWN_REQUESTED = false;
    private static ARPTableManager arpTableManager;

    static {
        arpTableManager = new ARPTableManager(GeneralConfigurationManager.getARPTableFileLocation());
    }

    public OpenNebulaServiceCenterManagement() {
    }

    //TODO: de citit si mac si server def de la opennebula
    public static void main(String[] args) {
        try {
            //	        try {
            //
            //	            Client client = null;
            //	            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
            //	            OneResponse info = VirtualMachinePool.info(client, -2);
            //	            if (info.isError()) {
            //	                System.err.println(info.getErrorMessage());
            //	                System.err.println(info.getMessage());
            //	            } else {
            //	               GlobalLoopLogger.getLogger().info(info.getErrorMessage());
            //	               GlobalLoopLogger.getLogger().info(info.getMessage());
            //	            }
            //	        } catch (Exception e) {
            //	             throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
            //	        }
            //        Client client = null;
            //        try {
            //            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
            //        } catch (Exception e) {
            //             throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
            //        }
            //        br.close();
            //	                proc.getInputStream().close();                             proc.getOutputStream().close();            proc.getErrorStream().close();   proc.destroy();
            //
            //	        HostPool hostPool = new HostPool(client);
            //	        hostPool.processInfo(HostPool.info(client));
            //	        Iterator<Host> hostIterator = hostPool.iterator();
            //	        while (hostIterator.hasNext()) {
            //	            Host host = hostIterator.next();
            //	           GlobalLoopLogger.getLogger().info(host.info().getMessage().replace("</", "</\n") + "\n \n");
            //	           GlobalLoopLogger.getLogger().info(host.xpath("/HOST/NAME"));
            //	        }
            //System.out.println(HostPool.info(client).getMessage());
            //        Client client = null;
            //        try {
            //            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
            //        } catch (Exception e) {
            //        }
            //        VirtualMachinePool pool = new VirtualMachinePool(client);
            //        pool.processInfo(VirtualMachinePool.info(client, -2));
            //        Iterator<VirtualMachine> hostIterator = pool.iterator();
            //        try {
            //            while (hostIterator.hasNext()) {
            //                VirtualMachine virtualMachine = hostIterator.next();
            //                OneResponse response = virtualMachine.info();
            ////                System.out.println(virtualMachine.status());
            //
            //                System.out.println(OpennebulaUtils.formatXML(response.getMessage()));
            //                break;
            //            }
            //        } catch (Exception e) {
            //            e.printStackTrace();
            //        }
            //        Client client = null;
            //                try {
            //                    client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
            //                } catch (Exception e) {
            //                }
            //        PhysicalHost physicalHost = new PhysicalHost();
            //        physicalHost.setId(4);
            ////        physicalHost.setHostname("Node4");
            ////        physicalHost.setMac("20:cf:30:52:73:20");
            //        physicalHost.setHostname("Node5");
            //        physicalHost.setMac("70:71:bc:b1:6f:e5");
            //        try {
            //              new OpenNebulaServiceCenterManagement().wakeUpServer(physicalHost);  ;
            //
            //        } catch (ServiceCenterAccessException e) {
            //            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
            //        }
            new OpenNebulaServiceCenterManagement().getVMInfo(338);
        } catch (ServiceCenterAccessException ex) {
            Logger.getLogger(OpenNebulaServiceCenterManagement.class.getName()).log(Level.SEVERE, null, ex);
        }

    }

    public VirtualTaskInfo getVMInfo(Integer vmID) throws ServiceCenterAccessException {

        Client client = null;
        try {
            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }

        VirtualMachine virtualMachine = new VirtualMachine(vmID, client);
        OneResponse response = virtualMachine.info();
        String data = response.getMessage();
        VirtualTaskInfo virtualTaskInfo = null;

        try {
            virtualTaskInfo = OpenNebulaInfoXMLParser.parseVirtualMachineInfo(data);
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }

        return virtualTaskInfo;
    }

    public List<VirtualTaskInfo> getPendingVirtualMachines() throws ServiceCenterAccessException {
        List<VirtualTaskInfo> pendingVMs = new ArrayList<VirtualTaskInfo>();

        Client client = null;
        try {
            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }

        VirtualMachinePool pool = new VirtualMachinePool(client);
        pool.processInfo(VirtualMachinePool.info(client, -2));
        Iterator<VirtualMachine> hostIterator = pool.iterator();
        try {
            while (hostIterator.hasNext()) {
                VirtualMachine virtualMachine = hostIterator.next();
                if (virtualMachine.status().equals("pend")) {
                    OneResponse response = virtualMachine.info();
                    String data = response.getMessage();
                    pendingVMs.add(OpenNebulaInfoXMLParser.parseVirtualMachineInfo(data));
                }
            }
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.toString(), e.getCause());
        }
        return pendingVMs;
    }

    public List<VirtualTaskInfo> getAllVirtualMachines() throws ServiceCenterAccessException {
        List<VirtualTaskInfo> runningVMs = new ArrayList<VirtualTaskInfo>();

        Client client = null;
        try {
            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }

        VirtualMachinePool pool = new VirtualMachinePool(client);
        pool.processInfo(VirtualMachinePool.info(client, -2));
        Iterator<VirtualMachine> hostIterator = pool.iterator();
        try {
            while (hostIterator.hasNext()) {
                VirtualMachine virtualMachine = hostIterator.next();
                OneResponse response = virtualMachine.info();
                String data = response.getMessage();
                runningVMs.add(OpenNebulaInfoXMLParser.parseVirtualMachineInfo(data));
            }
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.toString(), e.getCause());
        }
        return runningVMs;
    }

    public List<ServerInfo> getDefinedServers() throws ServiceCenterAccessException {
        List<ServerInfo> serverInfos = new ArrayList<ServerInfo>();

        Client client = null;
        try {
            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }

        HostPool hostPool = new HostPool(client);
        hostPool.info();
        Iterator<Host> hostIterator = hostPool.iterator();
        try {
            while (hostIterator.hasNext()) {
                Host host = hostIterator.next();
                try {
                    OneResponse response = host.info();
                    String data = response.getMessage();

                    ServerInfo serverInfo = OpenNebulaInfoXMLParser.parseServerInfo(data);
                    String hostname = serverInfo.getHostName();
                    if (arpTableManager.hasMAC(hostname)) {
                        serverInfo.setMacAddress(arpTableManager.getMAC(hostname));
                    } else {
                        String mac = getServerMAC(hostname);
                        arpTableManager.addMAC(hostname, mac);
                        serverInfo.setMacAddress(mac);
                    }

                    //read CPU Frequency
                    //try to read trough ssh the output of cpufreq-info -l : gives CPU frequency hardware limits
                    //if no reponse, read CPU freq from OpenNebula
                    {
                        try {

                            String cmd = "/usr/bin/ssh -t -t Node1 cpufreq-info -l";

                            //execute the wakeonlan command
                            Process proc = Runtime.getRuntime().exec(cmd);
                            OutputStream outputStream = proc.getOutputStream();
                            InputStream stdin = proc.getInputStream();
                            InputStreamReader isr = new InputStreamReader(stdin);

                            //log the wakeonlan output
                            BufferedReader br = new BufferedReader(isr);
                            String line = br.readLine();
                            if (line != null) {
                                GlobalLoopLogger.getLogger().info(line);
                                String[] values = line.split(" ");
                                String cpuFreq = values[values.length - 1];
                                if (cpuFreq.matches("\\d+")) {
                                    serverInfo.setCpuFrequency(Float.parseFloat(cpuFreq));
                                }
                            }

                            br.close();
                            isr.close();
                            stdin.close();
                            outputStream.close();
                            proc.getInputStream().close();
                            proc.getOutputStream().close();
                            proc.getErrorStream().close();
                            proc.destroy();


                        } catch (Exception ex) {
                            GlobalLoopLogger.error(ex);
                        }
                    }

                    serverInfos.add(serverInfo);
                } catch (Exception e) {
                    GlobalLoopLogger.getLogger().info("Error monitoring " + host.getId() + ". Probably is offline. Because incomplete data about the server was recorded by OpenNebula, it will be IGNORED.");
                }
            }

        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        } finally {
            arpTableManager.writeArpTable();
        }

        return serverInfos;
    }

    public ServerInfo getServerInfo(PhysicalHost physicalHost) throws ServiceCenterAccessException {

        Client client = null;
        try {
            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }
        Host host = new Host(physicalHost.getId(), client);

        OneResponse response = host.info();
        if (response.isError()) {
            throw new ServiceCenterAccessException(response.getErrorMessage());
        }
        ServerInfo dto = null;
        while (dto == null || dto.getTotalMem() == 0) {
            if (SHUTDOWN_REQUESTED) {
                return new ServerInfo();
            }
            try {
                response = host.info();
                dto = OpenNebulaInfoXMLParser.parseServerInfo(response.getMessage());
                dto.setMacAddress(getServerMAC(physicalHost.getHostname()));
            } catch (Exception e) {
                throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
            }
        }
        return dto;
    }

    /**
     * @param infoVirtual
     * @return the ID of the newly deployed VM
     * @throws ServiceCenterAccessException
     */
    public VirtualTaskInfo createAndDeployVirtualMachine(VirtualTaskInfo infoVirtual, PhysicalHost physicalHost) throws ServiceCenterAccessException {

        //create a connection to the OpenNebula manager
        Client client = null;
        try {
            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }

        VirtualNetworkInfo virtualNetworkInfo = infoVirtual.getNetworkInfo();
        String vmTemplate = infoVirtual.getVmTemplate();

        //TODO: poate de pus optiune de modificat intre atasare la VNET existent sau creare de VNET nou
//        String vnetTemplate = "A";
//
//        //create OpenNebula virtual network to attach the virtual machine to
//        OneResponse createNetworkResponse = VirtualNetwork.allocate(client, vnetTemplate);
//
//        //verify virtual network creation result
//        if (createNetworkResponse.isError()) {
//            throw new ServiceCenterAccessException(createNetworkResponse.getErrorMessage());
//        }

        //TODO: de vazut de unde cum iau IP-u
        vmTemplate = OpennebulaUtils.configureVMTemplate(vmTemplate, infoVirtual.getTaskName(),
                infoVirtual.getRequestedCPU(), infoVirtual.getRequestedMemory(),
                GeneralConfigurationManager.getVMNetworkID(), virtualNetworkInfo.getIp(),
                Integer.parseInt(virtualNetworkInfo.getIp().substring(virtualNetworkInfo.getIp().lastIndexOf(".") + 1)),
                virtualNetworkInfo.getVncPassword());

        //create virtual machine for OpenNebula
        OneResponse createVirtualMachineResponse = VirtualMachine.allocate(client, vmTemplate);

        //verify virtual machine creation result
        if (createVirtualMachineResponse.isError()) {
            VirtualNetwork.delete(client, infoVirtual.getNetworkInfo().getId());
            throw new ServiceCenterAccessException(createVirtualMachineResponse.getErrorMessage());
        } else {
            infoVirtual.setId(Integer.parseInt(createVirtualMachineResponse.getMessage()));
        }

        //retrieve a previously created virtual machine from the OpenNebula API
        VirtualMachine virtualMachine = new VirtualMachine(Integer.parseInt(createVirtualMachineResponse.getMessage()), client);

        //deploy the existing virtual machine onto the server having the OpenNebula ID   "physicalHost.getId()"
        OneResponse deployVirtualMachineResponse = virtualMachine.deploy(physicalHost.getId());

        //verify the deployment result
        if (deployVirtualMachineResponse.isError()) {
            //resubmit the virtual machine and redeploy
            resubmitAndDeployVirtualMachine(virtualMachine, physicalHost);
        } 

        VirtualMachine vm = new VirtualMachine(infoVirtual.getId(), client);
        GlobalLoopLogger.getLogger().debug("Waiting for " + infoVirtual.getTaskName() + " deployment");

        //wait until the virtual machine is running (passes trough states "prolog","pending")
        while (vm.lcmState() != 3 && vm.lcmState() != 0 && vm.lcmState() != 14) {
            if (SHUTDOWN_REQUESTED) {
                return infoVirtual;
            }
            try {
                Thread.sleep(10);
            } catch (InterruptedException e) {
                throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
            }
            vm.info();
        }

        //check if the virtual machine has failed to start after the deployment has completed
        //i.e. if an error has occurred when booting the virtual machine by the deployment target node's hypervisor
        if (vm.lcmStateStr().toLowerCase().contains("fail")) {
            GlobalLoopLogger.getLogger().info(infoVirtual.getTaskName() + " deployment failed");
            if (GeneralConfigurationManager.isWSCallbackEnabled()) {
                try {
                    BPELCallUtil.signalDepoloymentFailure("error");
                } catch (Exception e) {
                    GlobalLoopLogger.getLogger().info(e.toString());
                }
            }
        } else {
//            GlobalLoopLogger.getLogger().debug("Waiting for " + infoVirtual.getTaskName() + " to boot");
//            waitUntilTargetIsAlive(virtualNetworkInfo.getIp());
        }
        return infoVirtual;

    }

    public VirtualTaskInfo createVirtualMachine(VirtualTaskInfo infoVirtual) throws ServiceCenterAccessException {
        //create a connection to the OpenNebula manager
        Client client = null;
        try {
            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }

        VirtualNetworkInfo virtualNetworkInfo = infoVirtual.getNetworkInfo();
        String vmTemplate = infoVirtual.getVmTemplate();

        //TODO: poate de pus optiune de modificat intre atasare la VNET existent sau creare de VNET nou
//        String vnetTemplate = "A";
//
//        //create OpenNebula virtual network to attach the virtual machine to
//        OneResponse createNetworkResponse = VirtualNetwork.allocate(client, vnetTemplate);
//
//        //verify virtual network creation result
//        if (createNetworkResponse.isError()) {
//            throw new ServiceCenterAccessException(createNetworkResponse.getErrorMessage());
//        }

        //TODO: de vazut de unde cum iau IP-u
        vmTemplate = OpennebulaUtils.configureVMTemplate(vmTemplate, infoVirtual.getTaskName(),
                infoVirtual.getRequestedCPU() / 3000, infoVirtual.getRequestedMemory(),
                GeneralConfigurationManager.getVMNetworkID(), virtualNetworkInfo.getIp(),
                Integer.parseInt(virtualNetworkInfo.getIp().substring(virtualNetworkInfo.getIp().lastIndexOf(".") + 1)),
                virtualNetworkInfo.getVncPassword());

        //create virtual machine for OpenNebula
        OneResponse createVirtualMachineResponse = VirtualMachine.allocate(client, vmTemplate);

        //verify virtual machine creation result
        if (createVirtualMachineResponse.isError()) {
            VirtualNetwork.delete(client, infoVirtual.getNetworkInfo().getId());
            throw new ServiceCenterAccessException(createVirtualMachineResponse.getErrorMessage());
        } else {
            infoVirtual.setId(Integer.parseInt(createVirtualMachineResponse.getMessage()));
        }
        VirtualMachine vm = new VirtualMachine(infoVirtual.getId(), client);
        vm.info();
        while (!vm.lcmStateStr().toLowerCase().contains("boot") && !vm.lcmStateStr().toLowerCase().contains("runn")) {
            try {
                Thread.sleep(1000);
            } catch (InterruptedException e) {
                throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
            }
            vm.info();
        }
        return infoVirtual;
    }

    public void removeVirtualMachine(VirtualTaskInfo infoVirtual) throws ServiceCenterAccessException {

        //create a connection to the OpenNebula manager
        Client client = null;
        try {
            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }
        VirtualMachine vm = new VirtualMachine(infoVirtual.getId(), client);
        OneResponse finalizeResponse = vm.finalizeVM();
        if (finalizeResponse.isError()) {
            throw new ServiceCenterAccessException(finalizeResponse.getErrorMessage());
        }

    }

    public VirtualTaskInfo deployVirtualMachine(VirtualTaskInfo infoVirtual, PhysicalHost physicalHost) throws ServiceCenterAccessException {

        waitUntilSSHAvailable(physicalHost.getHostname());

        Client client = null;
        try {
            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }

        //todo: if commented below, opennebula default scheduler takes over

        //retrieve from the OpenNebula API an existing virtual machine
        VirtualMachine virtualMachine = new VirtualMachine(infoVirtual.getId(), client);

        //deploy the virtual machine onto the server having the OpenNebula ID =  physicalHost.getId()
        OneResponse deployVirtualMachineResponse = virtualMachine.deploy(physicalHost.getId());

        if (deployVirtualMachineResponse.isError()) {
            resubmitAndDeployVirtualMachine(virtualMachine, physicalHost);
        }
        VirtualMachine vm = new VirtualMachine(infoVirtual.getId(), client);

        GlobalLoopLogger.getLogger().debug("Waiting for " + infoVirtual.getTaskName() + " deployment");

        while (vm.lcmState() != 3 && vm.lcmState() != 0 && vm.lcmState() != 14) {
            if (SHUTDOWN_REQUESTED) {
                return infoVirtual;
            }
            try {
                Thread.sleep(1000);
            } catch (InterruptedException e) {
                throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
            }
            vm.info();

        }
        if (vm.lcmStateStr().toLowerCase().contains("fail")) {
            GlobalLoopLogger.getLogger().info(infoVirtual.getTaskName() + " deployment failed");
            throw new ServiceCenterAccessException(infoVirtual.getTaskName() + " deployment failed");
        }
//        else {
//            GlobalLoopLogger.getLogger().debug("Waiting for " + infoVirtual.getTaskName() + " to boot");
//            waitUntilTargetIsAlive(virtualNetworkInfo.getIp());
//	            GlobalLoopLogger.getLogger().debug("Restarting " + infoVirtual.getTaskName() + " and waiting to boot");
//	            restartInitialVM(virtualNetworkInfo.getIp());
//        }
        VirtualTaskInfo toBeReturned = null;
        try {
            toBeReturned = OpenNebulaInfoXMLParser.parseVirtualMachineInfo(vm.info().getMessage());
        } catch (Exception e) {
            GlobalLoopLogger.error(e);;
            throw new ServiceCenterAccessException(e.toString());
        }
        return toBeReturned;
    }

    public void startVirtualMachine(VirtualTaskInfo taskInfo) throws ServiceCenterAccessException {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void stopVirtualMachine(VirtualTaskInfo infoVirtual) throws ServiceCenterAccessException {
        Client client = null;
        try {
            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }
        VirtualMachine machine = new VirtualMachine(infoVirtual.getId(), client);
        OneResponse response = machine.stop();
        if (response.isError()) {
            throw new ServiceCenterAccessException(response.getErrorMessage());
        }
    }

    public void deleteVirtualMachine(VirtualTaskInfo infoVirtual) throws ServiceCenterAccessException {
        Client client = null;
        try {
            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }
        VirtualMachine machine = new VirtualMachine(infoVirtual.getId(), client);
//	        VirtualNetwork virtualNetwork = new VirtualNetwork(infoVirtual.getNetworkInfo().getId(), client);
        //
//	        OneResponse networkDeleteResponse = virtualNetwork.delete();
//	        if (networkDeleteResponse.isError()) {
//	            throw new ServiceCenterAccessException(networkDeleteResponse.getErrorMessage());
//	        }
        //
        OneResponse machineDeleteResponse = machine.finalizeVM();
        if (machineDeleteResponse.isError()) {
            throw new ServiceCenterAccessException(machineDeleteResponse.getErrorMessage());
        }

        machine.info();
        while (machine.lcmState() != 0) {
            if (SHUTDOWN_REQUESTED) {
                return;
            }
            try {
                Thread.sleep(10);
            } catch (InterruptedException e) {
                throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
            }
            machine.info();
        }


    }

    public void migrateVirtualMachine(VirtualTaskInfo taskInfo, PhysicalHost destination) throws ServiceCenterAccessException {
        Client client = null;
        try {
            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }

        //get a reference to an existing virtual machine having the OpenNebula ID = taskInfo.getId()
        VirtualMachine machine = new VirtualMachine(taskInfo.getId(), client);

        //issue a live migration or an offline migration depending on the configuration of the GCL
        OneResponse response =
                (GeneralConfigurationManager.getVMMigrationMechanism().equals("live"))
                ? machine.liveMigrate(destination.getId())
                : machine.migrate(destination.getId());

        if (response.isError()) {
            resubmitAndDeployVirtualMachine(machine, destination);
        }

        //wait for the migration to complete and the virtual machine to boot
        machine.info();
        while (machine.lcmState() != 3 && machine.lcmState() != 0 && machine.lcmState() != 14) {
            if (SHUTDOWN_REQUESTED) {
                return;
            }

            try {
                Thread.sleep(10);
            } catch (InterruptedException e) {
                throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
            }
            machine.info();

        }

    }

    public PhysicalHost addHost(PhysicalHost physicalHost) throws ServiceCenterAccessException {
//	        Client client = null;
//	        try {
//	            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
//	        } catch (Exception e) {
//	            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
//	        }

//	        //===========================================================================
//	        // !!!! MODIFICAT SA caute HOST-ul in cele existente deja in ONEHOST LIST
//	        //===========================================================================

//	        OneResponse response = Host.allocate(client, physicalHost.getHostname(), physicalHost.getIm(), physicalHost.getVmm(), physicalHost.getTm());
        //
//	        if (response.isError()) {
//	            throw new ServiceCenterAccessException(response.getErrorMessage());
//	        } else {
//	            physicalHost.setId(Integer.parseInt(response.getMessage()));
//	            Host host = new Host(physicalHost.getId(), client);
//	            host.disable();
//	        }
//	        HostPool hostPool = new HostPool(client);
//	        hostPool.processInfo(HostPool.info(client));
//	        Iterator<Host> hostIterator = hostPool.iterator();
//	        while (hostIterator.hasNext()) {
//	            Host host = hostIterator.next();
//	           //GlobalLoopLogger.getLogger().info(host.info().getMessage().replace("</", "</\n") + "\n \n");
//	            if (host.xpath("/HOST/NAME").equals(physicalHost.getHostname())) {
//	                physicalHost.setId(Integer.parseInt(host.xpath("/HOST/ID")));
//	                break;
//	            }
//	        }

//	         new Host(physicalHost.getId(), client).enable();

        return physicalHost;
    }

    public void removeHost(PhysicalHost physicalHost) throws ServiceCenterAccessException {
        Client client = null;
        try {
            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }
//	        Host host = new Host(physicalHost.getId(), client);
//	        OneResponse response = host.disable();
//	        if (response.isError()) {
//	            throw new ServiceCenterAccessException(response.getErrorMessage());
//	        }
        Host h1 = new Host(physicalHost.getId(), client);
        h1.info();
        while (h1.state() != -1) {
            if (SHUTDOWN_REQUESTED) {
                return;
            }
            GlobalLoopLogger.getLogger().info(h1.state());
            try {
                Thread.sleep(10);
            } catch (InterruptedException e) {
                throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
            }
            h1.info();
        }
        sendServerToSleep(physicalHost);

//	        h1.disable();


    }

    public void enableHost(PhysicalHost physicalHost) throws ServiceCenterAccessException {
        Client client = null;
        try {
            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }
        Host host = new Host(physicalHost.getId(), client);
        OneResponse response = host.enable();
        if (response.isError()) {
            throw new ServiceCenterAccessException(response.getErrorMessage());
        }

    }

    public void disableHost(PhysicalHost physicalHost) throws ServiceCenterAccessException {
        Client client = null;
        try {
            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }
        Host host = new Host(physicalHost.getId(), client);
        OneResponse response = host.disable();
        if (response.isError()) {
            throw new ServiceCenterAccessException(response.getErrorMessage());
        }
    }

    public void wakeUpServer(PhysicalHost physicalHost) throws ServiceCenterAccessException {
        try {

            String cmd = "";
            if (GeneralConfigurationManager.getNodesWakeUpMechanism().equals("python")) {
                cmd = "./scripts/manage_recs.py -i " + GeneralConfigurationManager.getRECSControllerIP() + " -s " + physicalHost.getMac() + "";
            } else {
                cmd = GeneralConfigurationManager.getNodesWakeUpMechanism() + " " + physicalHost.getMac();
            }
            //execute the wakeonlan command
            Process proc = Runtime.getRuntime().exec(cmd);
            OutputStream outputStream = proc.getOutputStream();
            InputStream stdin = proc.getInputStream();
            InputStreamReader isr = new InputStreamReader(stdin);

            //log the wakeonlan output
            BufferedReader br = new BufferedReader(isr);
            String line = br.readLine();
            if (line != null) {
                GlobalLoopLogger.getLogger().debug(line);
            }

            //wait until server responds to ping
            GlobalLoopLogger.getLogger().info("Waiting for " + physicalHost.getHostname() + " to respond to ping");
            waitUntilTargetIsAlive(physicalHost.getHostname());

            //wait until server responds to SSH connection request
            //needed because SSH is used by OpenNebula to deploy/migrate virtual machines
            GlobalLoopLogger.getLogger().info("Waiting for " + physicalHost.getHostname() + " to respond to SSH");
            waitUntilSSHAvailable(physicalHost.getHostname());

            br.close();
            isr.close();
            stdin.close();
            outputStream.close();
            proc.getInputStream().close();
            proc.getOutputStream().close();
            proc.getErrorStream().close();
            proc.destroy();

        } catch (Exception ex) {
//	            //System.err.println("Error:" + ex.getMessage());
            GlobalLoopLogger.error(ex);
        }
        Client client = null;
        try {
            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }
        Host host = new Host(physicalHost.getId(), client);
        host.enable();
    }

    private void pingTarget(String ip) throws ServiceCenterAccessException {
        String pingCmd = GeneralConfigurationManager.getPingLocation() + " " + ip;
        try {
            Runtime r = Runtime.getRuntime();
            Process p = r.exec(pingCmd);

            BufferedReader in = new BufferedReader(new InputStreamReader(p.getInputStream()));
            GlobalLoopLogger.getLogger().info("Waiting until " + ip + " responds to ping");
            in.readLine();

            in.close();
            p.getInputStream().close();
            p.getOutputStream().close();
            p.getErrorStream().close();
            p.destroy();
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }
    }

    private String getServerMAC(String ip) throws ServiceCenterAccessException {
        String mac = null;
        pingTarget(ip);
        String pingCmd = GeneralConfigurationManager.getArpLocation() + " " + ip;
        try {
            Runtime r = Runtime.getRuntime();
            Process p = r.exec(pingCmd);

            //TODO: nu parseaza nime mac
            BufferedReader in = new BufferedReader(new InputStreamReader(p.getInputStream()));
            mac = in.readLine();

            String[] response = in.readLine().split(" ");
            ArrayList<String> content = new ArrayList<String>(3);
//            boolean etherWordEncountered = false;
            for (String s : response) {
                if (s.length() > 0) {
                    content.add(s);
                }
            }
            mac = content.get(2);
            GlobalLoopLogger.getLogger().info(mac);

            in.close();
            p.getInputStream().close();
            p.getOutputStream().close();
            p.getErrorStream().close();
            p.destroy();
        } catch (Exception e) {
            throw new ServiceCenterAccessException(e.getMessage(), e.getCause());
        }
        return mac;
    }

    public boolean serverIsAlive(String ip) throws ServiceCenterAccessException {


        String pingCmd = GeneralConfigurationManager.getPingLocation() + " " + ip;
        boolean isAlive = false;

        try {
            Runtime r = Runtime.getRuntime();
            Process p = r.exec(pingCmd);

            BufferedReader in = new BufferedReader(new InputStreamReader(p.getInputStream()));
            String inputLine;
            GlobalLoopLogger.getLogger().info("Checking if " + ip + " responds to ping (if it is alive)");
            inputLine = in.readLine();
            inputLine = in.readLine();
            if (inputLine.toLowerCase().contains("unreachable")) {
                isAlive = false;
            } else {
                isAlive = true;
            }
            p.getInputStream().close();
            p.getOutputStream().close();
            p.getErrorStream().close();
            p.destroy();
            in.close();

        } catch (IOException e) {
            GlobalLoopLogger.error(e);;
        }

        return isAlive;

    }

    private void waitUntilTargetIsAlive(String ip) {

        String pingCmd = GeneralConfigurationManager.getPingLocation() + " " + ip;
        boolean ok = false;
        while (!ok) {
            try {
                Runtime r = Runtime.getRuntime();
                Process p = r.exec(pingCmd);

                BufferedReader in = new BufferedReader(new InputStreamReader(p.getInputStream()));
                String inputLine;
                GlobalLoopLogger.getLogger().info("Waiting until " + ip + " responds to ping");
                while ((inputLine = in.readLine()) != null) {
                    if (SHUTDOWN_REQUESTED) {
                        in.close();
                        p.getInputStream().close();
                        p.getOutputStream().close();
                        p.getErrorStream().close();
                        p.destroy();
                        return;
                    }
//	                    GlobalLoopLogger.getLogger().info(inputLine);

                    if (!inputLine.toLowerCase().contains("unreachable") && !inputLine.toLowerCase().equals("")
                            && inputLine.toLowerCase().contains("64 bytes")) {
                        ok = true;
                        GlobalLoopLogger.getLogger().info(ip + " responded to ping");
                        in.close();
                        p.getInputStream().close();
                        p.getOutputStream().close();
                        p.getErrorStream().close();
                        p.destroy();
                        break;

                    }
                    try {
                        Thread.currentThread().sleep(1000);
                    } catch (InterruptedException ex) {
                        GlobalLoopLogger.getLogger().info(ex);
                    }

                }
                p.getInputStream().close();
                p.getOutputStream().close();
                p.getErrorStream().close();
                p.destroy();
//	                in.close();

            } catch (IOException e) {
                GlobalLoopLogger.error(e);;
            }
        }
    }

    private void waitUntilTargetIsOff(String ip) {

        String pingCmd = GeneralConfigurationManager.getPingLocation() + " " + ip;
        boolean ok = false;
        while (!ok) {
            try {
                Runtime r = Runtime.getRuntime();
                Process p = r.exec(pingCmd);

                BufferedReader in = new BufferedReader(new InputStreamReader(p.getInputStream()));
                String inputLine;
                GlobalLoopLogger.getLogger().info("Waiting until " + ip + " Does not respond to ping anymore");
                while ((inputLine = in.readLine()) != null) {
                    if (SHUTDOWN_REQUESTED) {
                        in.close();
                        p.getInputStream().close();
                        p.getOutputStream().close();
                        p.getErrorStream().close();
                        p.destroy();
                        GlobalLoopLogger.getLogger().info("Not waiting anymore for " + ip + " to close. System shutdown issued");
                        return;
                    }
//	                    GlobalLoopLogger.getLogger().info(inputLine);

                    if (inputLine.toLowerCase().contains("unreachable") || inputLine.toLowerCase().equals("")
                            && !inputLine.toLowerCase().contains("64 bytes")) {
                        GlobalLoopLogger.getLogger().info(ip + " is off. Not responding to ping anymore");
                        ok = true;
                        in.close();
                        p.getInputStream().close();
                        p.getOutputStream().close();
                        p.getErrorStream().close();
                        p.destroy();
                        break;
                    }
                    try {
                        Thread.currentThread().sleep(1000);
                    } catch (InterruptedException ex) {
                        GlobalLoopLogger.getLogger().debug(ex);
                    }

                }
                p.getInputStream().close();
                p.getOutputStream().close();
                p.getErrorStream().close();
                p.destroy();
//	                in.close();

            } catch (IOException e) {
                GlobalLoopLogger.error(e);;
            }
        }
    }

    public void restartInitialVM(String newIP) {
        try {
            waitUntilTargetIsAlive(GeneralConfigurationManager.getDefaultVMIP());
            waitUntilSSHAvailable(GeneralConfigurationManager.getDefaultVMIP());
            String cmd = "/usr/bin/ssh " + GeneralConfigurationManager.getDefaultVMIP() + "  sudo reboot";
            Process proc = Runtime.getRuntime().exec(cmd);
            OutputStream outputStream = proc.getOutputStream();
            InputStream stdin = proc.getErrorStream();
            InputStreamReader isr = new InputStreamReader(stdin);
            BufferedReader br = new BufferedReader(isr);
            BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(outputStream));

//	            bufferedWriter.write(GeneralConfigurationManager.getVMUserPassword());
            bufferedWriter.newLine();
            bufferedWriter.flush();
            bufferedWriter.close();
            {
                String line = br.readLine();
                if (line != null) {
                    GlobalLoopLogger.getLogger().info(line);
                    if (line.contains("Connection refused")) {
                        br.close();
                        isr.close();
                        stdin.close();
                        bufferedWriter.close();
                        outputStream.close();
                        proc.getInputStream().close();
                        proc.getOutputStream().close();
                        proc.getErrorStream().close();
                        proc.destroy();
                        restartInitialVM(newIP);
                    }
//	                    else {
//	                        line = br.readLine();
//	                        br.close();
//	                        bufferedWriter.close();
//	                        proc.getInputStream().close();                             proc.getOutputStream().close();            proc.getErrorStream().close();   proc.destroy();
//	                    }
                }
            }

        } catch (Exception ex) {
            GlobalLoopLogger.getLogger().info("Error:" + ex.getMessage());
            GlobalLoopLogger.getLogger().debug(ex.toString());
        }
    }

    public void sendServerToSleep(PhysicalHost host) throws ServiceCenterAccessException {

        if (!checkIfAlive(host.getHostname())) {
            return;
        }

        try {
            //connect trough ssh to the target server IP = host.getHostname() and issue a shutdown command
            String cmd = "/usr/bin/ssh -t -t " + host.getHostname() + " sudo /sbin/shutdown -h now";
            Process proc = Runtime.getRuntime().exec(cmd);

//            BufferedReader in = new BufferedReader(new InputStreamReader(proc.getErrorStream()));
//            String inputLine;
//            while ((inputLine = in.readLine()) != null) {
//                GlobalLoopLogger.getLogger().info(inputLine);
//            }

            //wait until the server does not respond to ping anymore
            waitUntilTargetIsOff(host.getHostname());

            proc.getInputStream().close();
            proc.getOutputStream().close();
            proc.getErrorStream().close();
            proc.destroy();

        } catch (Exception ex) {
            GlobalLoopLogger.getLogger().info("Error:" + ex.getMessage());
            GlobalLoopLogger.getLogger().debug(ex.toString());
        }

    }

    public void waitUntilSSHAvailable(String ip) {
        if (SHUTDOWN_REQUESTED) {
            return;
        }
        try {
            boolean sshUp = false;
            String cmd = "/usr/bin/ssh " + ip + " echo ssh_ok";
            while (!sshUp) {
                Process proc = Runtime.getRuntime().exec(cmd);

                InputStreamReader isr = new InputStreamReader(proc.getInputStream());
                BufferedReader br = new BufferedReader(isr);
//	                GlobalLoopLogger.getLogger().info("Waiting until " + ip + " responds to SSH");
                {
                    String line = br.readLine();
                    if (line != null) {
//	                        if (!line.contains("@") & !line.contains("Pseudo-terminal")) {
                        if (!line.contains("ssh_ok")) {

                            isr.close();
                            br.close();
                            proc.getInputStream().close();
                            proc.getOutputStream().close();
                            proc.getErrorStream().close();
                            proc.destroy();
                            Thread.currentThread().sleep(10000);
//	                            GlobalLoopLogger.getLogger().info("Waiting for " + ip + " to respond to SSH");
                        } else {
                            GlobalLoopLogger.getLogger().info(ip + " has responded to SSH");
                            sshUp = true;
                            isr.close();
                            br.close();
                            proc.getInputStream().close();
                            proc.getOutputStream().close();
                            proc.getErrorStream().close();
                            proc.destroy();
                            break;

                        }
//	                    line = br.readLine();   Nu mai trebe citit k se apeleaza waitUntilSSHAvailable
                    } else {
                        proc.getInputStream().close();
                        proc.getOutputStream().close();
                        proc.getErrorStream().close();
                        proc.destroy();
                    }
                }
            }
            // waitUntilTargetIsAlive(newIP);
        } catch (Exception ex) {
            GlobalLoopLogger.getLogger().debug(ex.toString());
        }
    }

    private boolean checkIfAlive(String ip) {
        String pingCmd = GeneralConfigurationManager.getPingLocation() + " " + ip;
        boolean ok = false;

        try {
            Runtime r = Runtime.getRuntime();
            Process p = r.exec(pingCmd);

            BufferedReader in = new BufferedReader(new InputStreamReader(p.getInputStream()));
            String inputLine;
            GlobalLoopLogger.getLogger().info("Checking if " + ip + " is alive");
            inputLine = in.readLine();
            inputLine = in.readLine();
            if (inputLine != null) {

                if (inputLine.toLowerCase().contains("unreachable") || inputLine.toLowerCase().equals("")
                        && !inputLine.toLowerCase().contains("64 bytes")) {
                    GlobalLoopLogger.getLogger().info(ip + " is off. No turn off needed");
                    in.close();
                    p.getInputStream().close();
                    p.getOutputStream().close();
                    p.getErrorStream().close();
                    p.destroy();
                    ok = false;
                } else {
                    p.getInputStream().close();
                    p.getOutputStream().close();
                    p.getErrorStream().close();
                    p.destroy();
                    ok = true;
                }

            } else {
                in.close();
                p.getInputStream().close();
                p.getOutputStream().close();
                p.getErrorStream().close();
                p.destroy();
                ok = false;
            }

        } catch (IOException e) {
            GlobalLoopLogger.getLogger().info(e);
        }


        return ok;

    }

    public String getEnergyConsumptionInfo(PhysicalHost host) throws ServiceCenterAccessException {
        return null;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public void terminateRunningOperations() {
        SHUTDOWN_REQUESTED = true;




    }

    private static class OpennebulaUtils {

        private static Pattern cpuPattern = Pattern.compile("CPU\\s*=.*");
        private static Pattern memPattern = Pattern.compile("MEMORY\\s*=.*");
        private static Pattern netPatern = Pattern.compile("NIC.*\\[.*\\]");
        private static Pattern vncPortPatern = Pattern.compile("PORT\\s*=.*");
        private static Pattern bridgePattern = Pattern.compile("BRIDGE\\s*=.*");
        private static Pattern namePattern = Pattern.compile("NAME\\s*=.*");

        //TODO: de setat si VNC password in case i need it
        static String configureVMTemplate(String source, String vmName, Double cpuValue,
                Integer memoryValue, String attachedNetworkID, String requestedIP, Integer vncPort, String vncPassword) {
            String result = source;

            Matcher nameMatcher = namePattern.matcher(result);
            if (nameMatcher.find()) {
                result = result.replace(result.substring(nameMatcher.start(), nameMatcher.end()), "NAME = " + vmName);
            }

            Matcher cpuMatcher = cpuPattern.matcher(result);
            if (cpuMatcher.find()) {
                result = result.replace(result.substring(cpuMatcher.start(), cpuMatcher.end()), "CPU = " + cpuValue);
            }

            Matcher memMatcher = memPattern.matcher(result);
            if (memMatcher.find()) {
                result = result.replace(result.substring(memMatcher.start(), memMatcher.end()), "MEMORY = " + memoryValue);

            }

            Matcher nicMatcher = netPatern.matcher(result);
            if (nicMatcher.find()) {
                result = result.replace(result.substring(nicMatcher.start(), nicMatcher.end()),
                        " NIC = [ NETWORK_ID = \"" + attachedNetworkID
                        + "\" , IP=\" " + requestedIP + "\" ] ");
            }

            Matcher vncPortMatcher = vncPortPatern.matcher(result);
            if (vncPortMatcher.find()) {
                result = result.replace(result.substring(vncPortMatcher.start(), vncPortMatcher.end()), " PORT = \"" + vncPort + "\", ");
            }

            return result;
        }

        static String formatXML(String unformattedXml) {
            try {
                final Document document = parseXmlFile(unformattedXml);

                OutputFormat format = new OutputFormat(document);
                format.setLineWidth(65);
                format.setIndenting(true);
                format.setIndent(2);
                Writer out = new StringWriter();
                XMLSerializer serializer = new XMLSerializer(out, format);
                serializer.serialize(document);

                return out.toString();
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }

        private static Document parseXmlFile(String in) {
            try {
                DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
                DocumentBuilder db = dbf.newDocumentBuilder();
                InputSource is = new InputSource(new StringReader(in));
                return db.parse(is);
            } catch (ParserConfigurationException e) {
                throw new RuntimeException(e);
            } catch (SAXException e) {
                throw new RuntimeException(e);
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
//	        static String extractBridgeInfo(String source) {
//	            Matcher bridgeMatcher = bridgePattern.matcher(source);
//	            bridgeMatcher.find();
//	            return source.substring(bridgeMatcher.start(), bridgeMatcher.end()).split("=")[1].trim();
//	        }
    }

    private void resubmitAndDeployVirtualMachine(VirtualMachine machine, PhysicalHost host) throws ServiceCenterAccessException {
        GlobalLoopLogger.info("Resubmiting and deploying " + machine.getName() + " to " + host.getHostname());
        machine.resubmit();
        OneResponse deployVirtualMachineResponse = machine.deploy(host.getId());
        if (deployVirtualMachineResponse.isError()) {
            throw new ServiceCenterAccessException(deployVirtualMachineResponse.getErrorMessage());
        }
    }

    public void terminate() {
        SHUTDOWN_REQUESTED = true;
    }
}

