/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.actionEnforcementModule.serviceCenterManagement.util;

import ro.utcn.dsrl.utils.config.GeneralConfigurationManager;
import ro.utcn.dsrl.utils.misc.SoapInvoker;

import javax.xml.soap.SOAPException;
import java.io.IOException;

/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */

public class BPELCallUtil {
    private BPELCallUtil(){
        
    }
    
    public static void signalDeploymentComplete(String message) throws IOException, SOAPException{
         SoapInvoker.performSOAPInvocation(GeneralConfigurationManager.getCallbackServiceURL(),
                            GeneralConfigurationManager.getCallbackServiceOperation(), 
                            GeneralConfigurationManager.getCallbackServiceNamespace(),
                            "deploymentResult",message);
        
    }
    
    public static void signalDepoloymentFailure(String message) throws IOException, SOAPException{
//         SoapInvoker.performSOAPInvocation(GeneralConfigurationManager.getCallbackServiceURL(),
//                            GeneralConfigurationManager.getCallbackServiceOperation(),
//                            GeneralConfigurationManager.getCallbackServiceNamespace(),
//                            "deploymentResult",message);
    }
    
    
}
