/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/

package ro.utcn.dsrl.actionPlanningModule.utils;

import java.util.Queue;
import ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.concepts.ContextAction;

/**
 *
 * @author Georgiana
 */
public class ActionPlan {
    private Queue<ContextAction> actions ;
    private double entropy;
    public ActionPlan(Queue<ContextAction> actions, double entropy){
        this.actions = actions;
        this.entropy = entropy;
    }

    /**
     * @return the actions
     */
    public Queue<ContextAction> getActions() {
        return actions;
    }

    /**
     * @param actions the actions to set
     */
    public void setActions(Queue<ContextAction> actions) {
        this.actions = actions;
    }

    /**
     * @return the entropy
     */
    public double getEntropy() {
        return entropy;
    }

    /**
     * @param entropy the entropy to set
     */
    public void setEntropy(double entropy) {
        this.entropy = entropy;
    }
}
