/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.client;

import ro.utcn.dsrl.utils.exposedFunctionality.rmiAPI.RMIAPI;
import ro.utcn.dsrl.utils.exposedFunctionality.rmiAPI.RMICommand;
import ro.utcn.dsrl.utils.commonDtos.ActivityDto;
import ro.utcn.dsrl.utils.config.GeneralConfigurationManager;
import ro.utcn.dsrl.utils.logging.GlobalLoopLogger;

import java.io.Serializable;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */

public class Client {
    public static void main(String[] args) {

        {
            //first leg
            Serializable[] dtos = new Serializable[3];
            for (int i = 0; i < 2; i++) {
                ActivityDto dto = new ActivityDto();
                dto.setEpkbID("DummyService_1");
                dto.setIp("192.168.1._a_" + i);
                dtos[i] = dto;
            }

//            ActivityDto dto = new ActivityDto();
//            dto.setEpkbID("SORT_SERVICE");
//            dto.setIp("192.168.1._a_" + 2);
//            dtos[2] = dto;

            try {
                RMIAPI rmiapi;
                Registry registry = LocateRegistry.getRegistry(GeneralConfigurationManager.getRMIAPIPort());
                rmiapi = (RMIAPI) registry.lookup(RMIAPI.class.getName());
                rmiapi.processCommand(RMICommand.SERVICE_COLLECTION_DEPLOYMENT_NOTIFICATION, dtos);
            } catch (Exception ex) {
                GlobalLoopLogger.error(ex);
                ex.printStackTrace();
            }

        }
//        {
//            //second leg
//            Serializable[] dtos = new Serializable[5];
//            for (int i = 0; i < 4; i++) {
//                ActivityDto dto = new ActivityDto();
//                dto.setEpkbID("IO_INTENSIVE_SERVICE");
//                dto.setIp("192.168.1._b_" + i);
//                dtos[i] = dto;
//            }
//
//            ActivityDto dto = new ActivityDto();
//            dto.setEpkbID("MEM_INTENSIVE_SERVICE");
//            dto.setIp("192.168.1._a_" + 5);
//            dtos[4] = dto;
//
//            try {
//                RMIAPI rmiapi;
//                Registry registry = LocateRegistry.getRegistry(GeneralConfigurationManager.getRMIAPIPort());
//                rmiapi = (RMIAPI) registry.lookup(RMIAPI.class.getName());
//                rmiapi.processCommand(RMICommand.SERVICE_COLLECTION_DEPLOYMENT_NOTIFICATION, dtos);
//            } catch (Exception ex) {
//                GlobalLoopLogger.error(ex);
//                ex.printStackTrace();
//            }
//
//        }


//        {
//            //first leg
//            Serializable[] dtos = new Serializable[2];
//            {
//                ActivityDto dto = new ActivityDto();
//                dto.setEpkbID("A");
//                dto.setIp("192.168.1._a_");
//                dtos[0] = dto;
//            }
//            {
//                ActivityDto dto = new ActivityDto();
//                dto.setEpkbID("C");
//                dto.setIp("192.168.1._c_");
//                dtos[1] = dto;
//
//            }
//            try {
//                RMIAPI rmiapi;
//                Registry registry = LocateRegistry.getRegistry(GeneralConfigurationManager.getRMIAPIPort());
//                rmiapi = (RMIAPI) registry.lookup(RMIAPI.class.getName());
//                rmiapi.processCommand(RMICommand.SERVICE_COLLECTION_DEPLOYMENT_NOTIFICATION, dtos);
//            } catch (Exception ex) {
//                GlobalLoopLogger.error(ex);
//                ex.printStackTrace();
//            }
//
//        }

//         {
//            //second leg
//            Serializable[] dtos = new Serializable[1];
//
//            {
//                ActivityDto dto = new ActivityDto();
//                dto.setEpkbID("B");
//                dto.setIp("192.168.1._b_");
//                dtos[0] = dto;
//            }
//
//            try {
//                RMIAPI rmiapi;
//                Registry registry = LocateRegistry.getRegistry(GeneralConfigurationManager.getRMIAPIPort());
//                rmiapi = (RMIAPI) registry.lookup(RMIAPI.class.getName());
//                rmiapi.processCommand(RMICommand.SERVICE_COLLECTION_DEPLOYMENT_NOTIFICATION, dtos);
//            } catch (Exception ex) {
//                GlobalLoopLogger.error(ex);
//                ex.printStackTrace();
//            }
//
//        }


//        System.setProperty("java.awt.headless","false");
//		String[] jadeArgs = new String[]{"-port","1235",WorkloadSchedulerAgent.class.getName() + ":" + WorkloadSchedulerAgent.class.getName()};
//        jade.Boot.main(jadeArgs);
    }

}
