/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.workloadScheduler.workloadGenerator;

import ro.utcn.dsrl.utils.commonDtos.ActivityDiskDto;
import ro.utcn.dsrl.utils.commonDtos.ActivityDto;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by IntelliJ IDEA.
 * User: oneadmin
 * Date: 10/20/11
 * Time: 5:52 PM
 * To change this template use File | Settings | File Templates.
 */
public class GenericWorkloadGenerator {
    protected Map<String, ActivityDto> possibleTaskPool;

    {
        possibleTaskPool = new HashMap<String, ActivityDto>();
        ActivityDiskDto baseDiskDto = new ActivityDiskDto();
        baseDiskDto.setFormat("ext3");
        baseDiskDto.setPath("./");
        baseDiskDto.setSize(1024);
        baseDiskDto.setType("disk");
        Collection<ActivityDiskDto> diskDtoCollection = new ArrayList<ActivityDiskDto>(1);
        diskDtoCollection.add(baseDiskDto);
        {
            ActivityDto taskType = new ActivityDto();
            taskType.setTaskName("MEM_SERVICE");
            taskType.setServiceName("MEM_SERVICE");
            taskType.setEpkbID("MEM_SERVICE");
            taskType.setRequestedCores(5);
            taskType.setCpuWeight(0.2f);
            taskType.setMemWeight(0.8f);
            taskType.setRequestedCPUMax(500);
            taskType.setRequestedCPUMin(200);
            taskType.setRequestedMemoryMax(3000);
            taskType.setRequestedMemoryMin(2000);
            taskType.setDiskDtoCollection(diskDtoCollection);
            possibleTaskPool.put(taskType.getTaskName(), taskType);
        }
        {
            ActivityDto taskType = new ActivityDto();
            taskType.setTaskName("CPU_SERVICE");
            taskType.setServiceName("CPU_SERVICE");
            taskType.setEpkbID("CPU_SERVICE");
            taskType.setRequestedCores(8);
            taskType.setCpuWeight(0.8f);
            taskType.setMemWeight(0.2f);
            taskType.setRequestedCPUMax(2000);
            taskType.setRequestedCPUMin(1500);
            taskType.setRequestedMemoryMax(600);
            taskType.setRequestedMemoryMin(100);
            taskType.setDiskDtoCollection(diskDtoCollection);
            possibleTaskPool.put(taskType.getTaskName(), taskType);
        }
        {
            ActivityDto taskType = new ActivityDto();
            taskType.setTaskName("IO_SERVICE");
            taskType.setServiceName("IO_SERVICE");
            taskType.setEpkbID("IO_SERVICE");
            taskType.setRequestedCores(5);
            taskType.setCpuWeight(0.5f);
            taskType.setMemWeight(0.5f);
            taskType.setRequestedCPUMax(700);
            taskType.setRequestedCPUMin(100);
            taskType.setRequestedMemoryMax(600);
            taskType.setRequestedMemoryMin(100);
            taskType.setDiskDtoCollection(diskDtoCollection);
            possibleTaskPool.put(taskType.getTaskName(), taskType);
        }
        {
            ActivityDto taskType = new ActivityDto();
            taskType.setTaskName("MATRIX_SERVICE");
            taskType.setServiceName("MATRIX_SERVICE");
            taskType.setEpkbID("MATRIX_SERVICE");
            taskType.setRequestedCores(6);
            taskType.setCpuWeight(0.6f);
            taskType.setMemWeight(0.4f);
            taskType.setRequestedCPUMax(700);
            taskType.setRequestedCPUMin(100);
            taskType.setRequestedMemoryMax(1000);
            taskType.setRequestedMemoryMin(505);
            taskType.setDiskDtoCollection(diskDtoCollection);
            possibleTaskPool.put(taskType.getTaskName(), taskType);
        }
        {
            ActivityDto taskType = new ActivityDto();
            taskType.setTaskName("SORT_SERVICE");
            taskType.setServiceName("SORT_SERVICE");
            taskType.setEpkbID("SORT_SERVICE");
            taskType.setRequestedCores(4);
            taskType.setCpuWeight(0.7f);
            taskType.setMemWeight(0.3f);
            taskType.setRequestedCPUMax(1500);
            taskType.setRequestedCPUMin(700);
            taskType.setRequestedMemoryMax(500);
            taskType.setRequestedMemoryMin(200);
            taskType.setDiskDtoCollection(diskDtoCollection);
            possibleTaskPool.put(taskType.getTaskName(), taskType);
        }
        {
            ActivityDto taskType = new ActivityDto();
            taskType.setTaskName("SEARCH_SERVICE");
            taskType.setServiceName("SEARCH_SERVICE");
            taskType.setEpkbID("SEARCH_SERVICE");
            taskType.setRequestedCores(4);
            taskType.setCpuWeight(0.6f);
            taskType.setMemWeight(0.4f);
            taskType.setRequestedCPUMax(1700);
            taskType.setRequestedCPUMin(1000);
            taskType.setRequestedMemoryMax(800);
            taskType.setRequestedMemoryMin(400);
            taskType.setDiskDtoCollection(diskDtoCollection);
            possibleTaskPool.put(taskType.getTaskName(), taskType);
        }

    }
}
