/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.concepts;

import edu.stanford.smi.protegex.owl.model.RDFProperty;

import java.util.Collection;
import java.util.Iterator;

/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */

public interface ApplicationActivityDiskInfo extends BusinessContextResource {

    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#applicationActivityDiskInfoProperties

    Collection getApplicationActivityDiskInfoProperties();

    RDFProperty getApplicationActivityDiskInfoPropertiesProperty();

    boolean hasApplicationActivityDiskInfoProperties();

    Iterator listApplicationActivityDiskInfoProperties();

    void addApplicationActivityDiskInfoProperties(Object newApplicationActivityDiskInfoProperties);

    void removeApplicationActivityDiskInfoProperties(Object oldApplicationActivityDiskInfoProperties);

    void setApplicationActivityDiskInfoProperties(Collection newApplicationActivityDiskInfoProperties);


    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#diskFormat

    String getDiskFormat();

    RDFProperty getDiskFormatProperty();

    boolean hasDiskFormat();

    void setDiskFormat(String newDiskFormat);


    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#diskSize

    int getDiskSize();

    RDFProperty getDiskSizeProperty();

    boolean hasDiskSize();

    void setDiskSize(int newDiskSize);


    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#diskType

    String getDiskType();

    RDFProperty getDiskTypeProperty();

    boolean hasDiskType();

    void setDiskType(String newDiskType);


    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#physicalPath

    String getPhysicalPath();

    RDFProperty getPhysicalPathProperty();

    boolean hasPhysicalPath();

    void setPhysicalPath(String newPhysicalPath);
}
