/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.concepts;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;

/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */

public interface CPU extends SimpleResource {
    //TODO: de bagat eventual weight

    List<Core> getAssociatedCores();

    void setAssociatedCores(List<Core> newAssociatedCores);

    void addAssociatedCore(Core oldAssociatedCore);

    void removeAssociatedCore(Core oldAssociatedCore);


    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#cacheRate

    Double getCacheRate();

    boolean hasCacheRate();

    void setCacheRate(Double newCacheRate);


    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#cpuClockRate

    Double getCpuClockRate();

    boolean hasCpuClockRate();

    void setCpuClockRate(Double newCpuClockRate);


    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#partOf

    Collection getPartOf();

    boolean hasPartOf();

    Iterator listPartOf();

    void addPartOf(ContextElement newPartOf);

    void removePartOf(ContextElement oldPartOf);

    void setPartOf(Collection newPartOf);


    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#cpuCoreCount

    int getCpuCoreCount();

    boolean hasCpuCoreCount();

    void setCpuCoreCount(int newCpuCoreCount);
}
