/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.concepts;

import java.util.List;

/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */

public interface ContextPolicy extends ContextElement {
    String getPolicyName();

    void setPolicyName(String policyName);

    List<ContextResource> getPolicySubject();

    void setPolicySubject(List<ContextResource> policySubject);

    void addPolicySubject(ContextResource policySubject);

    void removePolicySubject(ContextResource policySubject);

    List<ContextResource> getPolicyTarget();

    void setPolicyTarget(List<ContextResource> policyTarget);

    void addPolicyTarget(ContextResource policySubject);

    void removePolicyTarget(ContextResource policySubject);

    Event getTriggerEvent();

    void setTriggerEvent(Event event);

    String getEvaluationCondition();

    void setEvaluationCondition(String condition);

    boolean isRespected();

    void setRespected(boolean value);

    public String getIsRespectedPropertyName();

    float getPolicyWeight();

    boolean hasPolicyWeight();

    void setPolicyWeight(float newPolicyWeight);
}
