/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.concepts;

/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */

public interface GPI_KPI_Policy extends ContextPolicy {

    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#GPI_KPI_Threshold_Max
    float getGPI_KPI_Threshold_Max();

    void setGPI_KPI_Threshold_Max(float newGPI_KPI_Threshold_Max);

    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#GPI_KPI_Threshold_Min
    float getGPI_KPI_Threshold_Min();

    void setGPI_KPI_Threshold_Min(float newGPI_KPI_Threshold_Min);

    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#GPI_KPI_value
    float getGPI_KPI_value();

    void setGPI_KPI_value(float newGPI_KPI_value);

    Goal getPolicyGoal();

    void setPolicyGoal(Goal goal);

    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#policyAction
    ContextAction getPolicyAction();

    boolean hasPolicyAction();

    void setPolicyAction(ContextAction newPolicyAction);
}
