/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.concepts;

import java.util.Collection;
import java.util.Iterator;

/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */

public interface ITFacilityPassiveResource extends ServiceCenterITFacilityResource {

    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#associatedActiveResources

    Collection getAssociatedActiveResources();


    boolean hasAssociatedActiveResources();

    Iterator listAssociatedActiveResources();

    void addAssociatedActiveResources(ITFacilityActiveResource newAssociatedActiveResources);

    void removeAssociatedActiveResources(ITFacilityActiveResource oldAssociatedActiveResources);

    void setAssociatedActiveResources(Collection newAssociatedActiveResources);


    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#minimumValue

    Double getMinimumValue();

    boolean hasMinimumValue();

    void setMinimumValue(Double newMinimumValue);


    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#recordedValue

    Double getRecordedValue();

    boolean hasRecordedValue();

    void setRecordedValue(Double newRecordedValue);
}
