/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.concepts;


import java.util.Collection;

/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */

public interface ITFacilityResourceAdaptationAction extends ContextAction {

    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#associatedResources

    Collection getAssociatedResources();

    boolean hasAssociatedResources();

    void addAssociatedResources(ContextResource newAssociatedResources);

    void removeAssociatedResources(ContextResource oldAssociatedResources);

    void setAssociatedResources(Collection newAssociatedResources);


    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#facilityAction

    FacilityDefaultAction getFacilityAction();

    boolean hasFacilityAction();

    void setFacilityAction(FacilityDefaultAction newFacilityAction);


}
