/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.concepts;


import java.util.List;

/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */

public interface ServiceCenterITComputingResource extends ContextResource {

    List<Integer> getEnergyStates();

    void setEnergyStates(List<Integer> states);

    List<ApplicationActivity> getRunningActivities();

    void setRunningActivities(List<ApplicationActivity> states);

    boolean hasRunningActivities();

    void addRunningActivity(ApplicationActivity applicationActivity);

    void removeRunningActivity(ApplicationActivity applicationActivity);

    Double getMaximumWorkLoad();

    void setMaximumWorkLoad(Double value);

    Double getOptimalWorkLoad();

    void setOptimalWorkLoad(Double value);

    Double getCurrentWorkLoad();

    void setCurrentWorkLoad(Double value);

    Integer getCurrentEnergyState();

    void setCurrentEnergyState(Integer value);
}
