/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.concepts;

/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */

public interface ServiceCenterServer extends ComplexResource {
    //TODO: quantificare de currentWorkload pt server

    boolean hostsActivity(ApplicationActivity activity);

    String getIpAddress();

    void setIpAddress(String newIpAddress);

    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#macAddress

    String getMacAddress();

    void setMacAddress(String newMacAddress);

    public void resetInitialValues();

    public void markInitialValues();

    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#serviceCenterServerPolicy

    ITComputingContextPolicy getServiceCenterServerPolicy();

//    RDFProperty getServiceCenterServerPolicyProperty();

//    boolean hasServiceCenterServerPolicy();

    void setServiceCenterServerPolicy(ITComputingContextPolicy newServiceCenterServerPolicy);


    // Property http://www.semanticweb.org/ontologies/2010/6/ContextModel.owl#isCluster


}
