/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.contextAccessingAndProcessingAPI.main;

import edu.stanford.smi.protege.model.Project;
import edu.stanford.smi.protege.server.Server;
import edu.stanford.smi.protegex.owl.model.OWLModel;
import ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.api.EACMInstance;
import ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.concepts.ContextElement;
import ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.modelAPI.OntologyEACMInstance;
import ro.utcn.dsrl.contextAccessingAndProcessingAPI.ontologyServer.OntologyServerController;
import ro.utcn.dsrl.utils.logging.GlobalLoopLogger;


/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */


public class ContextAccessingAndProcessingMain {

    public static void main(String[] args) {
        try {
            OntologyServerController.startServer();

            Project p = Server.getInstance().getProject("EACMDatabase");
            EACMInstance instance = new OntologyEACMInstance((OWLModel) p.getKnowledgeBase());

            //delete all the previous context element instances
            for (ContextElement element : instance.getAllContextElementInstances()) {
                element.delete();
            }

            GlobalLoopLogger.getLogger().info("Waiting for EPKB synchronization ...");
 

            GlobalLoopLogger.getLogger().info("Synchronization complete");

            GlobalLoopLogger.getLogger().info("EACM ready");
         
        } catch (Exception ex) {
            GlobalLoopLogger.error(ex);
        }
    }
}
