/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.contextMonitoringModule.utils.objectToDTOMappers;


import ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.concepts.ApplicationActivity;
import ro.utcn.dsrl.utils.commonDtos.ActivityDto;

/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */

public class TaskToDtoMapper {

    private TaskToDtoMapper() {
    }

    public static ActivityDto map(ApplicationActivity activity) {

        ActivityDto dto = new ActivityDto();
        dto.setCpuWeight(activity.getCPUWeight());
        dto.setMemWeight(activity.getMEMWeight());
        dto.setHddWeight(activity.getHDDWeight());
        dto.setReceivedCores((int) activity.getNumberOfCoresAllocatedValue());
        dto.setReceivedCPU((int) activity.getCpuAllocatedValue());
        dto.setReceivedMemory((int) activity.getMemAllocatedValue());
        dto.setReceivedStorage((int) activity.getHddAllocatedValue());
        dto.setRequestedCores((int) activity.getNumberOfCoresRequiredValue());
        dto.setRequestedCPUMin((int) activity.getCpuRequiredMinValue());
        dto.setRequestedCPUMax((int) activity.getCpuRequiredMaxValue());
        dto.setRequestedMemoryMin((int) activity.getMemRequiredMinValue());
        dto.setRequestedMemoryMax((int) activity.getMemRequiredMaxValue());
        dto.setRequestedStorageMin((int) activity.getHddRequiredMinValue());
        dto.setRequestedStorageMax((int) activity.getHddRequiredMaxValue());
        dto.setTaskName(activity.getName());
        return dto;
    }
}
