/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextAccessAndProcessing.ContextAccessAndProcessingAPI;
import ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextAccessAndProcessing.impl.ContextAccessAndProcessing;
import ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.concepts.ApplicationActivity;
import ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.concepts.ContextElement;
import ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.concepts.QoSPolicy;
import ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.modelAPI.OntologyEACMInstance;
import ro.utcn.dsrl.contextAccessingAndProcessingAPI.util.exceptions.ContextModelAccessException;

import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * <br/>
 * <br/>
 * <p><strong>Technical University of Cluj Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */
public class Test {

    public static void main(String[] args) {

        //do not forget to run the GAMES_CAP project in order to
        //start the ontology server and expose the ontology for remote access

        try {
            ContextAccessAndProcessingAPI api = null;
            try {
                api = new ContextAccessAndProcessing();
                api.loadContextInstanceAndSetCurrent();
            } catch (ContextModelAccessException ex) {
                Logger.getLogger(Test.class.getName()).log(Level.SEVERE, null, ex);
            }
            OntologyEACMInstance instance = (OntologyEACMInstance) api.getCurrentContextInstance();

            for (int i = 0; i < 10; i++) {
                System.out.println(i);
                //create instances
                ApplicationActivity activity = instance.createApplicationActivity("Activity_1" + i);
                QoSPolicy policy = instance.createQoSPolicy("Policy_1" + i);
                // ApplicationActivity activity_2 = instance.createApplicationActivity("Activity_2" + i);
//
                //change instance values
                activity.addActivityPolicies(policy);
                activity.setCpuWeight(0.3f);
//
//            //querry for instance values
//                System.out.println("Activity CPU Weight: " + activity.getCPUWeight());
////
////            //query the EACMInstance for the number of application activities declared
                System.out.println("Activities count: " + instance.getAllApplicationActivityInstances().size());
////
                ContextElement retrievedElement = instance.getApplicationActivity("Activity_1" + i);
////            
                System.out.println("Retrieved Element name: " + retrievedElement.getLocalName());
//                instance.getApplicationActivity(activity_2.getName()).getLocalName();
//                instance.getContextResource(activity_2.getName()).getLocalName();
//                instance.getGPI_KPI_Policy(policy.getName()).getLocalName();
                System.out.println("Retrieved Element name: " + instance.getApplicationActivity(retrievedElement.getName()).getLocalName());
                System.out.println("Retrieved Element name: " + instance.getContextResource(retrievedElement.getName()).getLocalName());
                // System.out.println("Retrieved Element name: " + instance.getGPI_KPI_Policy(policy.getName()).getLocalName());

//                api.setGPI_KPI_Threshold(instance, policy, 200, 300);
            }
        } catch (Exception e) {
            e.printStackTrace();
            while (true) ;
        }
    }
}
