/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package main;

import ro.utcn.dsrl.mainModule.agents.MainAgent;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;

/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */
public class Main {

    public static void main(String[] args) {
        System.setProperty("java.awt.headless", "false");
        int port = 1234;
        while (true) {
            try {
                LocateRegistry.getRegistry(port).list();
            } catch (RemoteException e) {
                break;
            }
            port++;
        }
        String[] jadeArgs = new String[]{"-port", "" + port, MainAgent.class.getName() + ":" + MainAgent.class.getName()};
//		System.out.println(new File(".").getAbsolutePath());
//		System.exit(1);
        jade.Boot.main(jadeArgs);

        //TODO: de facut ceva cu pathu de la situations.xml pt standalone k nu i unde ar trebui sa fie
    }
}
