/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package aspects;

import ro.utcn.dsrl.utils.logging.GlobalLoopLogger;

import java.io.ByteArrayOutputStream;
import java.io.PrintStream;


public aspect ErrorStackTraceLoggingAspect {

    //insert pointcut for all the public methods
    pointcut publicCall(): execution( * *(..));

    //define what to do after a method has thrown an exception
    after() throwing (Throwable e): publicCall() {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        PrintStream p = new PrintStream(baos);
        e.printStackTrace(p);
        //used the Logger configured with Log4J to output the error
        GlobalLoopLogger.getLogger().error(baos.toString());
    }
}
