/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package aspects;

import ro.utcn.dsrl.actionEnforcementModule.actionEnforcement.ContextActionEnforcer;
import ro.utcn.dsrl.actionPlanningModule.reasoning.impl.ReinforcementLearningPlanningEngine;
import ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.api.EACMInstance;
import ro.utcn.dsrl.contextAccessingAndProcessingAPI.contextModel.concepts.ContextAction;

public aspect MonitoringSystemAnalysisAspect {

    before(ReinforcementLearningPlanningEngine rl, EACMInstance eacmInstance):
  target(rl) && args(eacmInstance) && call(* generateActionPlan(EACMInstance)){
        System.err.println("AAA " + eacmInstance.getAllServiceCenterServerInstances().size());
    }

    before(ContextActionEnforcer actionEnforcer, ContextAction action):
 target(actionEnforcer) && args(action) && call( * executeAction(ContextAction)){
        System.err.println("! Executing " + action);
    }

}