/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package test;

import org.opennebula.client.Client;
import org.opennebula.client.OneResponse;
import org.opennebula.client.vm.VirtualMachine;
import ro.utcn.dsrl.utils.config.GeneralConfigurationManager;
import ro.utcn.dsrl.utils.logging.GlobalLoopLogger;

import java.util.Random;

/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */


public class VMDeployer {
    private final static String NEBULA_RCP_ADDRESS = GeneralConfigurationManager.getOpenNebulaRCPAddress();
    private final static String NEBULA_CREDENTIALS = GeneralConfigurationManager.getOpenNebulaCredentials();
    //    private static int vmIndex = 0;
    private static Random random = new Random();

    public static void main(String[] args) {
        Client client = null;
        try {
            client = new Client(NEBULA_CREDENTIALS, NEBULA_RCP_ADDRESS);
        } catch (Exception e) {
            GlobalLoopLogger.getLogger().debug(e.toString());
        }
        String vmTemplate = "NAME   = " + "VM_" + 3 + " \n"
                + "CPU    = " + "1" + "\n"
                + "MEMORY = " + "500" + "\n"
                + "OS     = [\n"
                + "   boot = hd,\n"
                + "   ROOT = hda\n"
                + "    ]\n";

        String disksTemplate = "";
        disksTemplate +=
                "DISK   = [\n"
                        + "   type = fs ,\n"
                        + "   clone=no,\n"
                        + "   size = 256,\n"
                        + "   format = ext3,\n"
                        + "   target   = hda,\n"
                        + "   readonly = \"no\" \n"
                        + "   ]\n";

        vmTemplate += disksTemplate;
        vmTemplate +=
                "NIC = [ MAC    = \"00:11:01:02:03:04\"  ]\n";

        OneResponse oneResponse = VirtualMachine.allocate(client, vmTemplate);
        if (oneResponse.isError()) {
            System.out.println(oneResponse.getErrorMessage());
        } else {
            System.out.println(oneResponse.getMessage());
        }

//        String net = "";
//         OneResponse oneResponse = VirtualNetwork.allocate(client, net);
//        if (oneResponse.isError()) {
//            System.out.println(oneResponse.getErrorMessage());
//        } else {
//            System.out.println(oneResponse.getMessage());
//        }
    }
}
