/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.openNebulaPlugin.util.openNebulaHooks;

import ro.utcn.dsrl.utils.commonDtos.ActivityDto;
import ro.utcn.dsrl.utils.exposedFunctionality.rmiAPI.RMIAPI;
import ro.utcn.dsrl.utils.exposedFunctionality.rmiAPI.RMICommand;

import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

/**
 * <br/>
 * <br/>
 * <p><strong>Technical University of Cluj Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */
public class VMDeletedHook {
    public static void main(String[] args) throws RemoteException {
        try {
            RMIAPI rmiapi;
            Registry registry = LocateRegistry.getRegistry(1333);
            rmiapi = (RMIAPI) registry.lookup(RMIAPI.class.getName());
            ActivityDto activityDto = new ActivityDto();
            activityDto.setCloudID(Integer.parseInt(args[0]));
            rmiapi.processCommand(RMICommand.VM_REMOVED_HOOK_ACTIVATED, activityDto);
        } catch (Exception ex) {
            ex.printStackTrace();
        }

    }
}
