/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.utils.agentsCommunication;

/**
 * <br/>
 * <br/>
 * <p><strong>Technical University of Cluj Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */

import java.io.IOException;

import ro.utcn.dsrl.utils.logging.GlobalLoopLogger;
import jade.core.AID;
import jade.core.Agent;
import jade.lang.acl.ACLMessage;

public class InterAgentMessageBuilder {
	
	
	
	private InterAgentMessageBuilder() {
		super();
	}

	public static void sendMessage(Agent sender, Class receiverAgentClass,
			Object... parameters) {

		ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
		try {
			msg.setContentObject(parameters);
		} catch (IOException e) {
			GlobalLoopLogger.getLogger().debug(e.toString());
		}
		msg.addReceiver(new AID(receiverAgentClass.getName() + "@"
				+ sender.getContainerController().getPlatformName()));
		sender.send(msg);

	}
}
