/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.utils.commonDtos;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */


public class ApplicationDto implements Serializable {
    private List<ActivityDto> activities;
    private String applicationName;
    private String id;
    private String epkbID;



    public ApplicationDto(String applicationName) {
        this.applicationName = applicationName;
        this.id = applicationName;
        activities = new ArrayList<ActivityDto>();
    }

    public ApplicationDto(String applicationName, String id) {
        this.applicationName = applicationName;
        this.id = id;
        activities = new ArrayList<ActivityDto>();
    }


    public String getEpkbID() {
        return epkbID;
    }

    public void setEpkbID(String epkbID) {
        this.epkbID = epkbID;
    }


    public void addActivity(ActivityDto dto) {
        activities.add(dto);
    }

    public List<ActivityDto> getActivities() {
        return activities;
    }

    public String getApplicationName() {
        return applicationName;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }


    public void setActivities(List<ActivityDto> tasks) {
        activities = tasks;
    }

    public void addActivities(List<ActivityDto> tasks) {
        activities.addAll(tasks);
    }


}
