/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.utils.exposedFunctionality.jaxbBindingClasses;

import javax.xml.bind.annotation.*;

/**
 * <br/>
 * <br/>
 * <p><strong>Technical University of Cluj Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Hosts", propOrder = {
        "servers"
})

@XmlRootElement(name = "Hosts")
public class ServerList {
    @XmlElement(required = true, name = "Host")
    private ServerDescription[] servers;

    public ServerDescription[] getServers() {
        return servers;
    }

    public void setServers(ServerDescription[] servers) {
        this.servers = servers;
    }
}
