/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.utils.exposedFunctionality.jaxbBindingClasses;

import javax.xml.bind.annotation.*;

/**
 * <br/>
 * <br/>
 * <p><strong>Technical University of Cluj Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "powerUsageDescription", propOrder = {
        "whileIdle",
        "whileLoadedTo40",
        "whileLoadedTo100"
})

@XmlRootElement(name = "powerUsageDescription")
public class ServerPowerUsageDescription {

    @XmlElement(required = true)
    private int whileIdle;
    @XmlElement(required = true)
    private int whileLoadedTo40;
    @XmlElement(required = true)
    private int whileLoadedTo100;

    public int getWhileIdle() {
        return whileIdle;
    }

    public void setWhileIdle(int whileIdle) {
        this.whileIdle = whileIdle;
    }

    public int getWhileLoadedTo40() {
        return whileLoadedTo40;
    }

    public void setWhileLoadedTo40(int whileLoadedTo40) {
        this.whileLoadedTo40 = whileLoadedTo40;
    }

    public int getWhileLoadedTo100() {
        return whileLoadedTo100;
    }

    public void setWhileLoadedTo100(int whileLoadedTo100) {
        this.whileLoadedTo100 = whileLoadedTo100;
    }
}
