/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ro.utcn.dsrl.utils.logging;

import java.io.ByteArrayOutputStream;
import java.io.PrintStream;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */
public class GlobalLoopLogger {

    private static Logger logger;
    private static SimpleDateFormat dateFormat;

    static {
        logger = Logger.getLogger(GlobalLoopLogger.class.getName());
        dateFormat = new SimpleDateFormat("_dd_MM_HH_mm_");
        System.setProperty("glcExecutionDate", dateFormat.format(new Date()));
        PropertyConfigurator.configure("./config/log4j.properties");
    }

    public static Logger getLogger() {
        return logger;
    }

    public static void debug(Exception ex) {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        PrintStream p = new PrintStream(baos);
        ex.printStackTrace(p);
        logger.debug(baos);
    }

    public static void info(Object message){
        logger.info(message);
    }
    
    public static void error(Exception ex){
        logger.error(ex.toString());
        debug(ex);
    }

    public static void main(String[] args) {
        Date date = new Date();

        System.out.println(dateFormat.format(date));
    }
}
