/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.utils.misc;

import ro.utcn.dsrl.utils.exceptions.ApplicationException;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.ProtocolException;
import java.net.URL;

/**
 * Created by IntelliJ IDEA.
 * User: oneadmin
 * Date: 10/31/11
 * Time: 4:44 PM
 * To change this template use File | Settings | File Templates.
 */
public class RESTInvoker {

    private RESTInvoker() {

    }

    public static void performRestCall(String restURL, String content) throws ApplicationException {

        try {
            URL url = new URL(restURL);

            // make post mode connection
            HttpURLConnection urlc = (HttpURLConnection) url.openConnection();
            urlc.setRequestMethod("PUT");

            //use post mode
            urlc.setDoOutput(true);
            urlc.setAllowUserInteraction(false);

            PrintStream ps = new PrintStream(urlc.getOutputStream());
            ps.print(content);
            ps.close();

            // retrieve result
//        BufferedReader br = new BufferedReader(new InputStreamReader(urlc.getInputStream(), "UTF-8"));
//        StringBuilder sb = new StringBuilder();
//        String line;
//        while ((line = br.readLine()) != null) {
//            sb.append(line);
//            sb.append("\n");
//        }
//
//        br.close();
        } catch (Exception e) {
            throw new ApplicationException(e.toString());
        }
    }
}
