/**********************************************************************************************************
 * Copyright 2012, Distributed Systems Research Laboratory, Technical University of Cluj-Napoca, Romania 
 * http://dsrl.coned.utcluj.ro/
 *  
 * Licensed under the EUPL V.1.1 
 * 
 * European Union Public Licence V. 1.1  
 * You may obtain a copy of this license at
 * 
 * http://joinup.ec.europa.eu/software/page/eupl/licence-eupl
 *  
 **********************************************************************************************************/
package ro.utcn.dsrl.utils.misc;

import java.util.HashMap;

/**
 * <br/>
 * <br/>
 * <p><strong>GAMES Project - Global Control Loop</strong></p>
 * <p><strong>@Author: Technical University of Cluj-Napoca</strong></p>
 * <br/>
 * <a href=http://dsrl.coned.utcluj.ro/ > Distributed Systems research Laboratory </a>
 * <br/>Coordinator: Prof. dr. ing. Ioan Salomie E-mail: Ioan.Salomie@cs.utcluj.ro
 * <br/>
 * <br/>Developers:
 * <br/>Daniel Moldovan(Daniel.Moldovan@cs.utcluj.ro)
 * <br/>Georgiana Copil(Georgiana.Copil@cs.utcluj.ro)
 */

public class UIDGenerator {

    private static HashMap<String, Integer> uniqueIDs;

    private UIDGenerator() {
    }

    static {
        uniqueIDs = new HashMap<String, Integer>();
    }

    public static Integer generateID(Class c) {
        String name = c.getName();
        if (uniqueIDs.containsKey(name)) {
            Integer oldVal = uniqueIDs.get(name) + 1;
            uniqueIDs.put(name, oldVal);
            return oldVal;
        } else {
            Integer oldVal = 0;
            uniqueIDs.put(name, oldVal);
            return oldVal;
        }
    }
}
